#property copyright ""
#property link      ""
#define   MAGIC     20051024

//-------    --------------------------------
extern string _Parameters_Trade = "-----  ";
extern double Lots           = 0.1;     //    ok
extern int    StopLoss       = 30;      //    ok
extern int    TakeProfit     = 10;       //    ok
extern string TimeSetOrders  = "00:00"; //   (MT)ok
extern string TimeDelOrders  = "23:59"; //   (MT)
extern int    DistanceSet    = 10;      //    ok
extern int    Slippage       = 0;       //  
extern string Name_Expert   = "LimitDelOrders v1.0";
extern color  clOpenBuy     = LightBlue;    //   
extern color  clOpenSell    = LightCoral;   //   
extern color  clCloseBuy    = Blue;         //   
extern color  clCloseSell   = Red;          //   

extern int n=0;
//----    -------------------------------
int prevBar;
int o=0;
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
void deinit() {
  Comment("");TimeCurrent();
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void start() {

  if (TimeToStr(TimeCurrent(), TIME_MINUTES)==TimeSetOrders) SetOrders();
  if(o!=2)
  {OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
  if (OrderType()<2) {o=1;}
  OrderSelect(1,SELECT_BY_POS,MODE_TRADES);
  if (OrderType()<2) {o=1;}
  if (o==1)ModifyOrders();
  if (o==1)o=2;}

  if (TimeToStr(TimeCurrent(), TIME_MINUTES)==TimeDelOrders) {
    DeleteAllOrders();
    CloseAllPositions();
    o=0;
  }
  prevBar=Bars;
}

//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
void SetOrders() {
  double ldStop=0, ldTake=0;
  int    spr=MarketInfo(Symbol(), MODE_SPREAD);
  double pAsk=Ask-(DistanceSet+spr)*Point;
  double pBid=Bid+DistanceSet*Point;

  if (!ExistOrder(1)) {
    if (StopLoss!=0) ldStop=pAsk-StopLoss*Point;
    if (TakeProfit!=0) ldTake=pAsk+TakeProfit*Point;
    SetOrder(OP_BUYLIMIT, pAsk, ldStop, ldTake, 1);
  }
  if (!ExistOrder(2)) {
    if (StopLoss!=0) ldStop=pBid+StopLoss*Point;
    if (TakeProfit!=0) ldTake=pBid-TakeProfit*Point;
    SetOrder(OP_SELLLIMIT, pBid, ldStop, ldTake, 2);
  }
}


//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
void ModifyOrders () {
  bool fd, fep1, fep2;

  fep1=ExistPosition(1);
  fep2=ExistPosition(2);

  for (int i=OrdersTotal()-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol()) {
        fd=False;
        if (OrderType()==OP_BUYLIMIT && OrderMagicNumber()==MAGIC+1) {
          if (fep2) fd=OrderModify(OrderTicket(),OrderOpenPrice()+Point*10,OrderStopLoss()+Point*10,OrderTakeProfit()+Point*10,0,0);

        }
        if (OrderType()==OP_SELLLIMIT && OrderMagicNumber()==MAGIC+2) {
          if (fep1) fd=OrderModify(OrderTicket(),OrderOpenPrice()-Point*10,OrderStopLoss()-Point*10,OrderTakeProfit()-Point*10,0,0);
        }
        
      }
    }
  }
}



//+------------------------------------------------------------------+
//|               |
//+------------------------------------------------------------------+
bool ExistOrder(int mn) {
  bool Exist=False;
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC+mn) {
        Exist=True; break;
      }
    }
  }
  return(Exist);
}

//+------------------------------------------------------------------+
//|                        |
//+------------------------------------------------------------------+
bool ExistPosition(int mn) {
  bool Exist=False;
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC+mn) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          Exist=true; break;
        }
      }
    }
  }
  return(Exist);
}

//+------------------------------------------------------------------+
//|                                                   |
//| :                                                       |
//|   op     -                                               |
//|   pp     -                                                   |
//|   ldStop -                                            |
//|   ldTake -                                            |
//|   mn     -   MAGIC                                      |
//+------------------------------------------------------------------+
void SetOrder(int op, double pp, double ldStop, double ldTake, int mn) {
  color  clOpen;
  string lsComm=GetCommentForOrder();

  if (op==OP_BUYLIMIT) clOpen=clOpenBuy;
  else clOpen=clOpenSell;
  OrderSend(Symbol(),op,Lots,pp,Slippage,ldStop,ldTake,lsComm,MAGIC+mn,0,clOpen);
  
}

//+------------------------------------------------------------------+
//|          |
//+------------------------------------------------------------------+
string GetCommentForOrder() {
  return(Name_Expert);
}

//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+
void DeleteAllOrders() {
  bool fd;
  for (int i=OrdersTotal()-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderMagicNumber()>MAGIC && OrderMagicNumber()<=MAGIC+2) {
        if (OrderSymbol()==Symbol()) {
          if (OrderType()==OP_BUYLIMIT || OrderType()==OP_SELLLIMIT) {
            fd=OrderDelete(OrderTicket()) ;
            
          }
        }
      }
    }
  }
}

//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
void CloseAllPositions() {
  bool fc;
  for (int i=OrdersTotal()-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderMagicNumber()>MAGIC && OrderMagicNumber()<=MAGIC+2) {
        if (OrderSymbol()==Symbol()) {
          fc=False;
          if (OrderType()==OP_BUY) {
            fc=OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, clCloseBuy);
          }
          if (OrderType()==OP_SELL) {
            fc=OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, clCloseSell);
          }
          
        }
      }
    }
  }
}






//+------------------------------------------------------------------+

